/* Descripcin: Listado de la composicin de la cartera de acciones vigente del cliente y su valor en euros de 
las acciones del momento.
   
   Parmetros entrada: Fecha, identificador del cliente (NIF).
    
   Parmetros salida: Identificador de cartera, NIF, Ticker, 
   
    Tablas: CLIENTE, ORDEN_COMPRA_VENTA 

    Instrucciones: EXECUTE PROC_CARTERA ('01/04/2015','99999999B');

*/


create or replace PROCEDURE PROC_CARTERA (p_fecha DATE, p_cliente  VARCHAR2 ) AS

    -- se almacena en el cursor las acciones y la cantidad que componen la cartera del cliente
    CURSOR C1 is select car.NIF, ca.id_cartera, ca.ticker,SUM(ca.cantidad) suma
    from  cartera car, cartera_accion ca
    where ca.id_cartera=car.id_cartera
    and car.NIF =p_cliente
    and ca.fecha_inicio <= p_fecha and (ca.FECHA_FIN >= p_fecha OR ca.FECHA_FIN is null) 
    group by car.NIF, ca.id_cartera, ca.ticker; 
 
		v_precio_euro NUMBER (6,2);	     
    v_precio_dolar NUMBER (6,2);
    numero NUMBER;
    mensaje VARCHAR2(200);
    res VARCHAR2(200);
    err_num       NUMBER;
    err_msg       VARCHAR2(200);
    RSP           VARCHAR2(500);
    v_usuario     VARCHAR2(30);
   PAR_IN        VARCHAR2(30);
               
BEGIN

      SELECT USER into v_usuario
      FROM DUAL;    
      DBMS_OUTPUT.PUT_LINE('CARTERA, TICKER, PR.EURO, PR.DLAR');
		FOR fila IN C1 LOOP

         	 	-- se consulta el precio de la accin
          		select precio_euro, precio_dolar into v_precio_euro, v_precio_dolar
          		from precio_accion p
          		where p.ticker=fila.ticker 
          		and p.fecha =p_fecha;

                   DBMS_OUTPUT.PUT_LINE(fila.id_cartera || ' ' || fila.ticker || ' ' || v_precio_euro*fila.suma || ' ' || '' || ' ' || v_precio_dolar*fila.suma || ' ' || '$');
                                    
		END LOOP;
      INSERT INTO LOGS (Id_log,Fecha_ejecucin,Func_proc,Estado,descripcion) 
         VALUES (SECUENCIA_LOGS.NEXTVAL,SYSDATE,'PROC_CARTERA','OK',v_usuario);
         COMMIT;
            
 EXCEPTION
       WHEN NO_DATA_FOUND THEN
              err_num := SQLCODE;
              err_msg := SUBSTR(SQLERRM, 1, 200);

               RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

             -- Se inserta en la tabla LOGS para saber lo que se ejecuta.
            INSERT INTO LOGS (Id_log,Fecha_ejecucin,Func_proc,Par_entrada,Par_salida,Estado,descripcion)
              VALUES (secuencia_logs.nextval,SYSDATE, 'PROC_CARTERA', PAR_IN, 'RSP: '||RSP,'OK',v_usuario);
    
        WHEN OTHERS THEN
              err_num := SQLCODE;
              err_msg := SUBSTR(SQLERRM, 1, 200);

               RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

        INSERT INTO LOGS (Id_log,Fecha_ejecucin,Func_proc,Par_entrada,Par_salida,Estado,DESCRIPCION)
          VALUES (secuencia_logs.nextval,SYSDATE,'PR_PENDIENTES',PAR_IN,RSP,'ERROR',v_usuario);
                               
END PROC_CARTERA;


/* connect user/pwd@BD
DECLARE  
BEGIN
  proc_cartera(&1, &2);
END;
/                     
EXIT;
*/

    


