/* PROCEDIMIENTO PARA ACTUALIZAR EL VALOR DE CIERRE DEL PRECIO DE LAS ACCIONES  
   
    La hora de apertura de la bolsa es a las 09:00 horas y la hora de cierre es a las 17:30 horas.
       
    En la tabla de LOG quiero guardar lo que ejecuto y si sucede error. 

    En la tabla PRECIO_ACCIONES, existe un campo que es precio_dolar para almacenar el valor del dlar de la accin.
     Una posibilidad es preguntar al usuario si desea guardar el precio en dlar de la accin.
       * Si es que SI, se ejecuta la consulta a la tabla CAMBIO_DIVISA para obtener el valor del dlar en esa fecha.

PARMETROS:
      PAR IN: par_ticker varchar2, par_precio_euro number, par_fecha date
      PAR OUT: 

    Instrucciones: EXECUTE PR_CIERRE_DIARIO ('SAB',2.83,'12/06/2015');

 */

create or replace PROCEDURE PR_CIERRE_DIARIO (par_ticker varchar2, par_precio_euro number, par_fecha date) 
AS

   err_num       NUMBER;
   err_msg       VARCHAR2(200);
   RSP           VARCHAR2(500);           
   PAR_IN        VARCHAR2(500); 
   v_usuario     VARCHAR2(20);
   v_ticker      VARCHAR2(20);
   v_respusuario VARCHAR2(20);
   v_dolar       NUMBER;
   ERROR EXCEPTION;

          
	  BEGIN

                 select user into v_usuario
                 from dual;
                
                  PAR_IN:= par_ticker || ' ' || par_precio_euro || ' ' || par_fecha;

  -- Hay que realizar las comprobaciones de los parmetros:

     -- Comprobacin de par_ticker

     RSP := 'ERROR: El valor del parmetro ticker es nulo';
     IF par_ticker IS NULL THEN  RAISE ERROR; END IF;

     -- Comprobacin de par_precio_euro

     RSP := 'ERROR: El valor del parmetro precio es nulo';
     IF par_precio_euro  IS NULL THEN  RAISE ERROR; END IF;

     -- Comprobacin de par_fecha, se puede enfocar tb desde SYSDATE

      RSP := 'ERROR: El valor del parmetro fecha es nulo';
     IF par_fecha IS NULL THEN  RAISE ERROR; END IF;

     -- comprobar con una select que exite el ticker en la tabla 

           BEGIN
                select ticker into v_ticker
                 from accion
                 where ticker=par_ticker;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN
               RSP := 'ERROR: El ticker no existe';
               RAISE ERROR;
          END;

      /* DBMS_OUTPUT.PUT_LINE('Desea calcular el valor dlar (SI/NO): '); 
                  v_respusuario := '&RESPUESTA';
                           IF v_respusuario = 'NO' THEN
                         v_dolar:=0;
                           
                  ELSE
                           -- se consulta la tabla CAMBIO_DIVISA para saber el precio del dlar
                                select "VALOR_DLAR" into v_dolar
                                from CAMBIO_DIVISA
                                where fecha=par_fecha;
                  END IF;  */
                
                       -- se consulta la tabla CAMBIO_DIVISA para saber el precio del dlar
                              BEGIN
                                select "VALOR_DLAR" into v_dolar
                                from CAMBIO_DIVISA
                                where fecha=par_fecha;
                              EXCEPTION
                                WHEN NO_DATA_FOUND THEN
                                RSP := 'ERROR: El valor dlar no existe';
                                 RAISE error;
                             END;
                   
                           -- se inserta en la tabla PRECIOS_ACCION
                          INSERT INTO PRECIO_ACCION (ticker, precio_euro,precio_dolar,fecha) 
                          VALUES(par_ticker,par_precio_euro,v_dolar * par_precio_euro ,par_fecha); 
                  

                    DBMS_OUTPUT.PUT_LINE('Se actualiza el ticker: ' || par_ticker); 
	            
		               
                 -- Se actualiza la tabla LOGS para saber lo que se ha ejecutado.
               RSP := 'OK'; 
              INSERT INTO LOGS (Id_log,Fecha_ejecucin,Func_proc,Par_entrada,Par_salida,Estado, descripcion) 
                VALUES (SECUENCIA_LOGS.nextval,SYSDATE,'PR_CIERRE_DIARIO',PAR_IN,RSP,'OK',v_usuario);


         EXCEPTION
		
        WHEN error THEN
           INSERT INTO LOGS (Id_log,Fecha_ejecucin,Func_proc,Par_entrada,Par_salida,Estado, descripcion) 
            VALUES (SECUENCIA_LOGS.nextval,SYSDATE,'PR_CIERRE_DIARIO',PAR_IN,RSP,'ERROR',v_usuario);
     
       -- RETURN NULL;
        WHEN NO_DATA_FOUND THEN
              err_num := SQLCODE;
              err_msg := SUBSTR(SQLERRM, 1, 200);

               RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

                INSERT INTO LOGS (Id_log,Fecha_ejecucin,Func_proc,Par_entrada,Par_salida,Estado, descripcion) 
                VALUES (SECUENCIA_LOGS.nextval,SYSDATE,'PR_CIERRE_DIARIO',PAR_IN,RSP,'ERROR',v_usuario);
             

        WHEN OTHERS THEN
              err_num := SQLCODE;
              err_msg := SUBSTR(SQLERRM, 1, 200);

               RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

                INSERT INTO LOGS (Id_log,Fecha_ejecucin,Func_proc,Par_entrada,Par_salida,Estado,descripcion) 
                VALUES (SECUENCIA_LOGS.nextval,SYSDATE,'PR_CIERRE_DIARIO',PAR_IN,RSP,'ERROR',v_usuario);   
  
         END;