/* PROCEDIMIENTO PARA PERMITIR VISUALIZAR DATOS DE LA TABLA EST_PENDIENTES.

 El usuario ejecuta la llamada al procedimiento y le pasa como parmetro el ticker de la accin

Se realiza una SELECT a la tabla EST_PENDIENTES y se visualizan los datos por pantalla.

EXECUTE PR_PENDIENTES('SAB') ;

*/
   
create or replace PROCEDURE PR_PENDIENTES (v_ticker VARCHAR2) AS
-- Se realiza un cursor de la tabla de estadsticas para saber la cantidad de acciones pendientes
    
CURSOR C1 IS SELECT TICKER,ACCIONES_DISPO_BROKER acciones,NUM_CLIENTES ,ID ,FECHA 
               FROM est_pendientes
               WHERE ticker=v_ticker;
               
   err_num       NUMBER;
   err_msg       VARCHAR2(200);
   RSP           VARCHAR2(500);
   v_usuario     VARCHAR2(30);
   PAR_IN        VARCHAR2(30);
BEGIN
         PAR_IN := v_ticker;
         SELECT USER into v_usuario
         FROM DUAL;
             
             FOR fila1 IN C1 LOOP
               	     
	        EXIT WHEN C1%NOTFOUND;                     
                 -- Nmero de clientes que tienen la accin en su cartera de forma activa
           DBMS_OUTPUT.PUT_LINE ('TICKER,ACCIONES_DISPO_BROKER ,NUM_CLIENTES');
           DBMS_OUTPUT.PUT_LINE (fila1.TICKER);
           DBMS_OUTPUT.PUT_LINE (fila1.acciones);
           DBMS_OUTPUT.PUT_LINE (fila1.NUM_CLIENTES);
           DBMS_OUTPUT.PUT_LINE (fila1.fecha);
                        
	        END LOOP;
            -- Se inserta en la tabla LOGS para saber lo que se ejecuta.
            INSERT INTO LOGS (Id_log,Fecha_ejecucin,Func_proc,Par_entrada,Par_salida,Estado,descripcion)
               VALUES (secuencia_logs.nextval,SYSDATE, 'PR_PENDIENTES', PAR_IN, 'RSP: '||RSP,'OK',v_usuario);
    
   
EXCEPTION  
   WHEN NO_DATA_FOUND THEN
              err_num := SQLCODE;
              err_msg := SUBSTR(SQLERRM, 1, 200);

               RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

                INSERT INTO LOGS (Id_log,Fecha_ejecucin,Func_proc,Par_entrada,Par_salida,Estado) 
                VALUES (secuencia_logs.nextval,SYSDATE,'PR_PENDIENTES',PAR_IN,RSP,'ERROR');
                 COMMIT;

        WHEN OTHERS THEN
              err_num := SQLCODE;
              err_msg := SUBSTR(SQLERRM, 1, 200);

               RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

                INSERT INTO LOGS (Id_log,Fecha_ejecucin,Func_proc,Par_entrada,Par_salida,Estado) 
                VALUES (secuencia_logs.nextval,SYSDATE,'PR_PENDIENTES',PAR_IN,RSP,'ERROR');
               COMMIT;
	END;
