
/* TRIGGER PARA ACTUALIZAR LA TABLA EST_BENEFICIO
   Actualiza beneficio neto cartera por mes/cliente, se actualiza el ltimo da del mes para almacenar el beneficio neto en
   euros y el porcentaje de la cartera de acciones de un cliente.

*/

create or replace TRIGGER TR_BENEFICIO 
AFTER INSERT ON PRECIO_ACCION 
-- Se lanza cuando el da actual es el uno del mes mejor se lanza cuando se modifica 
-- la tabla PRECIO_ACCION.
DECLARE
-- Quiero ver el valor que tiene la cartera el primer da de mes.
--    CURSOR C1 is SELECT car.NIF, cacc.id_cartera, cacc.ticker,cacc.cantidad,cacc.FECHA_INICIO,cacc.FECHA_FIN
--                  FROM CARTERA car, CARTERA_ACCION cacc
--                  WHERE car.ID_CARTERA=cacc.id_cartera
--                  ORDER BY car.NIF;
-- Quiero ver el valor que tiene la cartera el ltimo da de mes.

ACCIONES_1 NUMBER;
ACCIONES_31 NUMBER;
DIA_1 VARCHAR2(10);
DIA_31 VARCHAR2(10);
PRECIO_1 NUMBER;
PRECIO_31 NUMBER;
BENEFICIO NUMBER;
BENEFICIOPOR NUMBER;
VALOR_31 NUMBER;
VALOR_1 NUMBER;
VALOR_TOTAL31 NUMBER;
VALOR_TOTAL1 NUMBER;
err_num       NUMBER;
err_msg       VARCHAR2(200);
RSP           VARCHAR2(500);
PAR_IN        VARCHAR2(30);
v_usuario     VARCHAR2(30);   
    
BEGIN
        
      DIA_1 := '01/' || EXTRACT(MONTH FROM (SYSDATE-1)) || '/' || EXTRACT(YEAR FROM (SYSDATE -1));
      DIA_31 := SYSDATE - 1;
    
   -- DBMS_OUTPUT.PUT_LINE (DIA_1 || ' ' || DIA_31);
    
  IF EXTRACT(DAY FROM SYSDATE) = 1 THEN
    -- Hago un bucle por cliente y dentro por accion y luego en cartera_acciones y precios.
      FOR cliente IN (SELECT NIF FROM CARTERA)  
      LOOP
            VALOR_TOTAL31:=0;
            VALOR_TOTAL1:=0;
          --  DBMS_OUTPUT.PUT_LINE('CLIENTE: ' || cliente.NIF);
         FOR ACCION IN (SELECT CA.TICKER FROM CARTERA C, CARTERA_ACCION CA 
                        WHERE C.ID_CARTERA=CA.ID_CARTERA AND C.NIF= cliente.NIF)
         LOOP            
          --  DBMS_OUTPUT.PUT_LINE('   ACCION: ' || ACCION.TICKER);
            VALOR_1 := 0;
            VALOR_31 := 0;
            FOR fila IN (SELECT car.NIF, cacc.id_cartera, cacc.ticker,cacc.cantidad,cacc.FECHA_INICIO,cacc.FECHA_FIN
                  FROM CARTERA car, CARTERA_ACCION cacc
                  WHERE car.ID_CARTERA=cacc.id_cartera and cliente.NIF = car.NIF AND CACC.TICKER=ACCION.TICKER ORDER BY car.NIF)
            LOOP
                      IF fila.FECHA_FIN is null THEN
                          IF fila.FECHA_INICIO <= SYSDATE -1 THEN
                              ACCIONES_31 := fila.cantidad;
                          END IF;
                      ELSE
                          IF fila.FECHA_INICIO <= SYSDATE - 1 AND SYSDATE - 1 < fila.FECHA_FIN THEN
                              ACCIONES_31 := fila.cantidad;
                          END IF;
                      END IF;
                      IF fila.FECHA_FIN is null THEN
                          IF fila.FECHA_INICIO <= DIA_1 THEN
                              ACCIONES_1 := fila.cantidad;
                          END IF;
                      ELSE
                          IF fila.FECHA_INICIO <= DIA_1 AND DIA_1 < fila.FECHA_FIN THEN
                              ACCIONES_1 := fila.cantidad;
                          END IF;
                      END IF;
                   --   DBMS_OUTPUT.PUT_LINE('       INTERNO: ' || fila.FECHA_INICIO || ' cantidad: ' || ACCIONES_31 || ' ' || ACCIONES_1);
                                   
             END LOOP;
                      SELECT PRECIO_EURO INTO PRECIO_1
                             FROM PRECIO_ACCION 
                             WHERE TICKER = ACCION.TICKER AND FECHA = DIA_1;
                      VALOR_1 := ACCIONES_1 * PRECIO_1;
                      SELECT PRECIO_EURO INTO PRECIO_31
                             FROM PRECIO_ACCION 
                             WHERE TICKER = ACCION.TICKER AND FECHA = DIA_31;                                  
                      VALOR_31 := ACCIONES_31 * PRECIO_31;
                      VALOR_TOTAL1 := VALOR_TOTAL1 + VALOR_1;
                      VALOR_TOTAL31 := VALOR_TOTAL31 + VALOR_31;
                   
                  -- DBMS_OUTPUT.PUT_LINE('   ACCION: ' || ACCION.TICKER || ' cantidad: ' || VALOR_1 || ' ' ||  VALOR_31 );
                
          END LOOP;
                     BENEFICIO := VALOR_TOTAL31 - VALOR_TOTAL1;
                     BENEFICIOPOR := BENEFICIO / VALOR_TOTAL1 * 100;
               -- Se actualiza la tabla del mdulo de estadsticas EST_CARTERA_MAYOR con los datos el cursor.
                INSERT INTO EST_BENEFICIO (ID,NIF,mes,beneficio_neto,porcentaje) 
                VALUES (SECUENCIA_EST_BENEFICIO.nextval,cliente.NIF,SYSDATE -1,BENEFICIO,BENEFICIOPOR);
                             
      END LOOP;
   
                -- Se actualiza la tabla LOGS para saber lo que se ha ejecutado. 
               INSERT INTO LOGS (Id_log,Fecha_ejecucin,Func_proc,Par_entrada,Par_salida,Estado,descripcion)
               VALUES (secuencia_logs.nextval,SYSDATE, 'TR_BENEFICIO', 'PAR_IN', 'RSP: '||RSP,'OK',v_usuario);
    END IF;



EXCEPTION

 WHEN NO_DATA_FOUND THEN
                       
              err_num := SQLCODE;
              err_msg := SUBSTR(SQLERRM, 1, 200);

               RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

                INSERT INTO LOGS (Id_log,Fecha_ejecucin,Func_proc,Par_entrada,Par_salida,Estado,descripcion) 
                VALUES (secuencia_logs.nextval,SYSDATE,'TR_BENEFICIO','PAR_IN',RSP,'ERROR',v_usuario);
               

        WHEN OTHERS THEN
              err_num := SQLCODE;
              err_msg := SUBSTR(SQLERRM, 1, 200);

               RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

                INSERT INTO LOGS (Id_log,Fecha_ejecucin,Func_proc,Par_entrada,Par_salida,Estado,descripcion) 
                VALUES (secuencia_logs.nextval,SYSDATE,'TR_BENEFICIO','PAR_IN',RSP,'ERROR',v_usuario);
            

END;