/* TRIGGER PARA ACTUALIZAR LA TABLA EST_NEGOCIADA la accin ms negociada y su volumen y fecha
 Se lanza cuando se ejecutan rdenes compra/venta, estado = 'EJECUTADA'

Entiendo que la opcin ms negociada es aquella que tiene ms nmero de id_orden.Se puede distinguir por 
tipo_orden ('COMPRADA','VENDIDA') o considerar la ms negociada de todas y no se distingue.
Se hacen dos cursores para distinguir compras y ventas y despus insertar el resultado en EST_NEGOCIADA.

En la tabla de LOG quiero guardar lo que ejecuto y si sucede error. 

Para estadsticas: UPDATE ORDEN_COMPRA_VENTA SET Estado= 'EJECUTADA',Fecha_ejec_mercado='05/06/2015'
                   WHERE Id_orden='OR006';                 

                   COMMIT;
                   SELECT * FROM EST_NEGOCIADA;

 
*/                  

create or replace TRIGGER TR_NEGOCIADA AFTER INSERT OR UPDATE OR DELETE 
  ON ORDEN_COMPRA_VENTA

  DECLARE
              -- se almacena en el cursor el n de veces y el volumen de la accin comprada
              CURSOR C1 is SELECT ticker,count(id_orden) contar,sum (cantidad) volumen,fecha_ejec_mercado
                           FROM ORDEN_COMPRA_VENTA
                            WHERE estado not in ('CANCELADA','PENDIENTE') 
                            AND tipo_orden='COMPRA'
                            GROUP BY ticker, fecha_ejec_mercado
                            HAVING count(id_orden)= (SELECT MAX(count(id_orden))
                                                     FROM  ORDEN_COMPRA_VENTA
                                                     WHERE estado not in ('CANCELADA','PENDIENTE') 
                                                     AND tipo_orden='COMPRA'
                                                    GROUP BY fecha_ejec_mercado,ticker);

             -- se almacena en el cursor el n de veces y el volumen de la accin vendida
             CURSOR C2 is  SELECT ticker,count(id_orden) contar,sum (cantidad) volumen,fecha_ejec_mercado
                           FROM ORDEN_COMPRA_VENTA
                            WHERE estado not in ('CANCELADA','PENDIENTE') 
                            AND tipo_orden='VENTA'
                            GROUP BY ticker, fecha_ejec_mercado
                            HAVING count(id_orden)= (SELECT MAX(count(id_orden))
                                                     FROM  ORDEN_COMPRA_VENTA
                                                     WHERE estado not in ('CANCELADA','PENDIENTE') 
                                                     AND tipo_orden='VENTA'
                                                    GROUP BY fecha_ejec_mercado,ticker);
    
    err_num       NUMBER;
    err_msg       VARCHAR2(200);
    RSP           VARCHAR2(500);
    PAR_IN        VARCHAR2(200);
    v_usuario     VARCHAR2(30); 

       BEGIN

             SELECT USER into v_usuario
             FROM DUAL;

               FOR fila1 IN C1 LOOP
               	     
			               EXIT WHEN C1%NOTFOUND; 
                          -- Se inserta en la tabla de estadsticas el valor de la accin de compra ms negociada.                       
                          INSERT INTO EST_NEGOCIADA (id,Ticker,volumen,Tipo,fecha) 
                          VALUES (secuencia_est_negociada.nextval,fila1.ticker,fila1.volumen,'COMPRA',fila1.fecha_ejec_mercado);
		END LOOP;
       
                FOR fila2 IN C2 LOOP
                      	     
			           EXIT WHEN C2%NOTFOUND; 
                          -- Se inserta en la tabla de estadsticas el valor de la accin de venta ms negociada.
                          INSERT INTO EST_NEGOCIADA (id,Ticker,volumen,Tipo,fecha) 
                          VALUES (secuencia_est_negociada.nextval,fila2.ticker,fila2.volumen,'VENTA',fila2.fecha_ejec_mercado);
                 
		END LOOP;

    
      -- Se actualiza la tabla LOGS para saber lo que se ha ejecutado.
      INSERT INTO LOGS (Id_log,Fecha_ejecucin,Func_proc,Par_entrada,Par_salida,Estado,descripcion) 
      VALUES (secuencia_logs.nextval,SYSDATE,'TR_EST_NEGOCIADA',PAR_IN,RSP,'OK',v_usuario);
      

 EXCEPTION
 
        WHEN NO_DATA_FOUND THEN
              err_num := SQLCODE;
              err_msg := SUBSTR(SQLERRM, 1, 200);

               RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

                INSERT INTO LOGS (Id_log,Fecha_ejecucin,Func_proc,Par_entrada,Par_salida,Estado,descripcion) 
                VALUES (secuencia_logs.nextval,SYSDATE,'TR_EST_NEGOCIADA',PAR_IN,RSP,'ERROR',v_usuario);
             

        WHEN OTHERS THEN
              err_num := SQLCODE;
              err_msg := SUBSTR(SQLERRM, 1, 200);

               RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

               INSERT INTO LOGS (Id_log,Fecha_ejecucin,Func_proc,Par_entrada,Par_salida,Estado,descripcion) 
               VALUES (secuencia_logs.nextval,SYSDATE,'TR_EST_NEGOCIADA','PAR_IN',RSP,'ERROR',v_usuario);
   
           
 END;